diff -urN ../VisualBoyAdvance-1.7.2/src/gb/GB.cpp ./src/gb/GB.cpp
--- ../VisualBoyAdvance-1.7.2/src/gb/GB.cpp	2004-05-14 04:35:26 +0900
+++ ./src/gb/GB.cpp	2006-08-25 22:30:09 +0900
@@ -2467,36 +4064,103 @@
 
   if(gbRomSize < gbRomSizes[gbRom[0x148]]) {
     gbRom = (u8 *)realloc(gbRom, gbRomSizes[gbRom[0x148]]);
+    for (int i = gbRomSize; i<gbRomSizes[gbRom[0x148]]; i++)
+        gbRom[i] = 0x00; // Not sure if it's 0x00, 0xff or random data...
+  }
+  // (it's in the case a cart is 'lying' on its size.
+  else if ((gbRomSize>gbRomSizes[gbRom[0x148]]) && (genericflashcardEnable))
+  {
+    gbRomSize = gbRomSize>>16;
+    gbRom[0x148] = 0;
+    if (gbRomSize)
+    {
+      while (!((gbRomSize & 1) || (gbRom[0x148] == 7)))
+      {
+        gbRom[0x148]++;
+        gbRomSize>>=1;
+      }
+      gbRom[0x148]++;
+    }
+    gbRom = (u8 *)realloc(gbRom, gbRomSizes[gbRom[0x148]]);
   }
   gbRomSize = gbRomSizes[gbRom[0x148]];
   gbRomSizeMask = gbRomSizesMasks[gbRom[0x148]];
 
-  if(gbRom[0x149] > 5) {
+
+  // The 'genericflashcard' option allows some PD to work.
+  // However, the setting is dangerous (if you let in enabled
+  // and play a normal game, it might just break everything).
+  // That's why it is not saved in the emulator options.
+  // Also I added some checks in VBA to make sure your saves will not be
+  // overwritten if you wrongly enable this option for a game
+  // you already played (and vice-versa, ie. if you forgot to
+  // enable the option for a game you played with it enabled, like Shawu Story).
+  u8 ramsize = genericflashcardEnable ? 5 : gbRom[0x149];
+  gbRom[0x149] = ramsize;
+
+  if ((gbRom[2] == 0x6D) && (gbRom[5] == 0x47) && (gbRom[6] == 0x65) && (gbRom[7] == 0x6E) &&
+      (gbRom[8] == 0x69) && (gbRom[9] == 0x65) && (gbRom[0xA] == 0x28) && (gbRom[0xB] == 0x54))
+  {
+    gbCheatingDevice = 1; // GameGenie
+    for (int i = 0; i < 0x20; i++) // Cleans GG hardware registers
+      gbRom[0x4000+i] = 0;
+  }
+  else if (((gbRom[0x104] == 0x44) && (gbRom[0x156] == 0xEA) && (gbRom[0x158] == 0x7F) &&
+            (gbRom[0x159] == 0xEA) && (gbRom[0x15B] == 0x7F)) || ((gbRom[0x165] == 0x3E) &&
+            (gbRom[0x166] == 0xD9) && (gbRom[0x16D] == 0xE1) && (gbRom[0x16E] == 0x7F)))
+    gbCheatingDevice = 2; // GameShark
+  else gbCheatingDevice = 0;
+
+  if(ramsize > 5) {
     systemMessage(MSG_UNSUPPORTED_RAM_SIZE,
                   N_("Unsupported ram size %02x"), gbRom[0x149]);
     return false;
   }
 
-  gbRamSize = gbRamSizes[gbRom[0x149]];
-  gbRamSizeMask = gbRamSizesMasks[gbRom[0x149]];
+  gbRamSize = gbRamSizes[ramsize];
+  gbRamSizeMask = gbRamSizesMasks[ramsize];
 
   if(gbRamSize) {
     gbRam = (u8 *)malloc(gbRamSize);
-    memset(gbRam, 0xFF, gbRamSize);
+    memset(gbRam, 0xff, gbRamSize);
   }
 
-  int type = gbRom[0x147];
+
+  gbRomType = gbRom[0x147];
+  if (genericflashcardEnable)
+  {
+    /*if (gbRomType<2)
+      gbRomType =3;
+    else if ((gbRomType == 0xc) || (gbRomType == 0xf) || (gbRomType == 0x12) ||
+             (gbRomType == 0x16) || (gbRomType == 0x1a) || (gbRomType == 0x1d))
+      gbRomType++;
+    else if ((gbRomType == 0xb) || (gbRomType == 0x11) || (gbRomType == 0x15) ||
+             (gbRomType == 0x19) || (gbRomType == 0x1c))
+      gbRomType+=2;
+    else if ((gbRomType == 0x5) || (gbRomType == 0x6))
+      gbRomType = 0x1a;*/
+      gbRomType = 0x1b;
+  }
+  else if (gbCheatingDevice == 1)
+    gbRomType = 0x55;
+  else  if (gbCheatingDevice == 2)
+    gbRomType = 0x56;
+
+  gbRom[0x147] = gbRomType;
 
   mapperReadRAM = NULL;
   
-  switch(type) {
+  switch(gbRomType) {
   case 0x00:
   case 0x01:
   case 0x02:
   case 0x03:
+  case 0x08:
+  case 0x09:
     // MBC 1
     mapper = mapperMBC1ROM;
     mapperRAM = mapperMBC1RAM;
+    mapperReadRAM = mapperMBC1ReadRAM;
     break;
   case 0x05:
   case 0x06:
@@ -2506,11 +4170,19 @@
     gbRamSize = 0x200;
     gbRamSizeMask = 0x1ff;
     break;
+  case 0x0b:
+  case 0x0c:
+  case 0x0d:
+    // MMM01
+    mapper = mapperMMM01ROM;
+    mapperRAM = mapperMMM01RAM;
+    break;
   case 0x0f:
   case 0x10:
   case 0x11:
   case 0x12:
   case 0x13:
+  case 0xfc:
     // MBC 3
     mapper = mapperMBC3ROM;
     mapperRAM = mapperMBC3RAM;
@@ -2522,6 +4194,7 @@
     // MBC5
     mapper = mapperMBC5ROM;
     mapperRAM = mapperMBC5RAM;
+    mapperReadRAM = mapperMBC5ReadRAM;
     break;
   case 0x1c:
   case 0x1d:
@@ -2529,6 +4202,7 @@
     // MBC 5 Rumble
     mapper = mapperMBC5ROM;
     mapperRAM = mapperMBC5RAM;
+    mapperReadRAM = mapperMBC5ReadRAM;
     break;
   case 0x22:
     // MBC 7
@@ -2536,6 +4210,38 @@
     mapperRAM = mapperMBC7RAM;
     mapperReadRAM = mapperMBC7ReadRAM;
     break;
+    // GG (GameGenie)
+  case 0x55:
+    mapper = mapperGGROM;
+    break;
+  case 0x56:
+    // GS (GameShark)
+    mapper = mapperGS3ROM;
+    break;
+  case 0xfd:
+    // TAMA5
+    if (gbRam!= NULL)
+    {
+      free(gbRam);
+      gbRam = NULL;
+    }
+
+    ramsize = 3;
+    gbRamSize = gbRamSizes[3];
+    gbRamSizeMask = gbRamSizesMasks[3];
+    gbRam = (u8 *)malloc(gbRamSize);
+    memset(gbRam, 0x0, gbRamSize);
+
+    gbTAMA5ramSize = 0x100;
+
+    if (gbTAMA5ram == NULL)
+      gbTAMA5ram = (u8 *)malloc(gbTAMA5ramSize);
+    memset(gbTAMA5ram, 0x0, gbTAMA5ramSize);
+
+    mapperRAM = mapperTAMA5RAM;
+    mapperReadRAM = mapperTAMA5ReadRAM;
+    mapperUpdateClock = memoryUpdateTAMA5Clock;
+    break;
   case 0xfe:
     // HuC3
     mapper = mapperHuC3ROM;
@@ -2549,11 +4255,11 @@
     break;
   default:
     systemMessage(MSG_UNKNOWN_CARTRIDGE_TYPE,
-                  N_("Unknown cartridge type %02x"), type);
+                  N_("Unknown cartridge type %02x"), gbRomType);
     return false;
   }
 
-  switch(type) {
+  switch(gbRomType) {
   case 0x03:
   case 0x06:
   case 0x0f:
@@ -2563,42 +4269,17 @@
   case 0x1d:
   case 0x1e:
   case 0x22:
+  case 0xfd:
   case 0xff:
     gbBattery = 1;
     break;
   }
 
-  if(gbRom[0x146] == 0x03) {
-    if(gbEmulatorType == 0 ||
-       gbEmulatorType == 2 ||
-       gbEmulatorType == 5)
-      gbSgbMode = 1;
-    else
-      gbSgbMode = 0;
-  } else
-    gbSgbMode = 0;
-  
-  if(gbRom[0x143] & 0x80) {
-    if(gbEmulatorType == 0 ||
-       gbEmulatorType == 1 ||
-       gbEmulatorType == 4 ||
-       gbEmulatorType == 5) {
-      gbCgbMode = 1;
-      gbVram = (u8 *)malloc(0x4000);
-      gbWram = (u8 *)malloc(0x8000);
-      memset(gbVram,0,0x4000);
-      memset(gbWram,0,0x8000);
-      memset(gbPalette,0, 2*128);
-    } else {
-      gbCgbMode = 0;
-    }
-  } else
-    gbCgbMode = 0;
-
   gbInit();
-  gbReset();
 
-  switch(type) {
+  //gbReset();
+
+  switch(gbRomType) {
   case 0x1c:
   case 0x1d:
   case 0x1e:
@@ -2608,16 +4289,163 @@
   return true;
 }
 
+int gbGetNextEvent (int clockTicks)
+{
+  if (register_LCDC & 0x80)
+  {
+    if(gbLcdTicks < clockTicks)
+        clockTicks = gbLcdTicks;
+
+    if(gbLcdTicksDelayed < clockTicks)
+      clockTicks = gbLcdTicksDelayed;
+
+    if(gbLcdLYIncrementTicksDelayed < clockTicks)
+      clockTicks = gbLcdLYIncrementTicksDelayed;
+  }
+
+  if(gbLcdLYIncrementTicks < clockTicks)
+    clockTicks = gbLcdLYIncrementTicks;
+
+  if(gbSerialOn && (gbSerialTicks < clockTicks))
+    clockTicks = gbSerialTicks;
+
+  if(gbTimerOn && (((gbInternalTimer) & gbTimerMask[gbTimerMode])+1 < clockTicks))
+    clockTicks = ((gbInternalTimer) & gbTimerMask[gbTimerMode])+1;
+
+  if(soundTicks && (soundTicks < clockTicks))
+    clockTicks = soundTicks;
+
+  if ((clockTicks<=0) || (gbInterruptWait))
+      clockTicks = 1;
+
+  return clockTicks;
+}
+
+void gbDrawLine()
+{
+  switch(systemColorDepth) {
+    case 16:
+    {
+      u16 * dest = (u16 *)pix +
+                   (gbBorderLineSkip+2) * (register_LY + gbBorderRowSkip+1)
+                   + gbBorderColumnSkip;
+      for(int x = 0; x < 160; ) {
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+        
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+        
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+        
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+        *dest++ = systemColorMap16[gbLineMix[x++]];
+      }
+      if(gbBorderOn)
+        dest += gbBorderColumnSkip;
+        *dest++ = 0; // for filters that read one pixel more
+    }
+    break;
+
+    case 24:
+    {
+      u8 *dest = (u8 *)pix +
+                 3*(gbBorderLineSkip * (register_LY + gbBorderRowSkip) +
+                 gbBorderColumnSkip);
+      for(int x = 0; x < 160;) {
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+        
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+        
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+        
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+        *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
+        dest+= 3;
+      }
+    }
+    break;
+
+    case 32:
+    {
+      u32 * dest = (u32 *)pix +
+                   (gbBorderLineSkip+1) * (register_LY + gbBorderRowSkip+1)
+                   + gbBorderColumnSkip;
+      for(int x = 0; x < 160;) {
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+        
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+        
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+        
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+        *dest++ = systemColorMap32[gbLineMix[x++]];
+      }
+    }
+    break;
+  }
+}
+
 void gbEmulate(int ticksToStop)
 {
   gbRegister tempRegister;
   u8 tempValue;
   s8 offset;
   
-  int clockTicks = 0;
+  clockTicks = 0;
   gbDmaTicks = 0;
 
   register int opcode = 0;
+
+  int opcode1 = 0;
+  int opcode2 = 0;
+  bool execute = false;
   
   while(1) {
 #ifndef FINAL_VERSION
@@ -2633,29 +4461,53 @@
       }
     }
 #endif
+
+    u16 oldPCW = PC.W;
+
     if(IFF & 0x80) {
       if(register_LCDC & 0x80) {
-        clockTicks = gbLcdTicks;
+          clockTicks = gbLcdTicks;
       } else
-        clockTicks = 100;
+        clockTicks = 1000;
+
+      clockTicks = gbGetNextEvent(clockTicks);
+
+      /*if(gbLcdTicksDelayed < clockTicks)
+        clockTicks = gbLcdTicksDelayed;
+
+      if(gbLcdLYIncrementTicksDelayed < clockTicks)
+        clockTicks = gbLcdLYIncrementTicksDelayed;
 
-      if(gbLcdMode == 1 && (gbLcdLYIncrementTicks < clockTicks))
+      if(gbLcdLYIncrementTicks < clockTicks)
         clockTicks = gbLcdLYIncrementTicks;
 
       if(gbSerialOn && (gbSerialTicks < clockTicks))
         clockTicks = gbSerialTicks;
 
-      if(gbTimerOn && (gbTimerTicks < clockTicks))
-        clockTicks = gbTimerTicks;
+      if(gbTimerOn && (((gbInternalTimer) & gbTimerMask[gbTimerMode])+1 < clockTicks))
+        clockTicks = ((gbInternalTimer) & gbTimerMask[gbTimerMode])+1;
 
       if(soundTicks && (soundTicks < clockTicks))
         clockTicks = soundTicks;
-    } else {
-      opcode = gbReadOpcode(PC.W++);
+
+      if ((clockTicks<=0) || (gbInterruptWait))
+          clockTicks = 1;*/
       
-      if(IFF & 0x100) {
-        IFF &= 0xff;
+    } else {
+
+      // First we apply the clockTicks, then we execute the opcodes.
+      opcode1 = 0;
+      opcode2 = 0;
+      execute = true;
+
+      opcode2 = opcode1 = opcode = gbReadOpcode(PC.W++);
+
+      // If HALT state was launched while IME = 0 and (register_IF & register_IE & 0x1F),
+      // PC.W is not incremented for the first byte of the next instruction.
+      if (IFF & 2)
+      {
         PC.W--;
+        IFF &= ~2;
       }
       
       clockTicks = gbCycles[opcode];
@@ -2663,24 +4515,66 @@
       switch(opcode) {
       case 0xCB:
         // extended opcode
-        opcode = gbReadOpcode(PC.W++);
+        opcode2 = opcode = gbReadOpcode(PC.W++);
         clockTicks = gbCyclesCB[opcode];
-        switch(opcode) {
-#include "gbCodesCB.h"
-        }
-        break;
-#include "gbCodes.h"    
+        break; 
       }
+      gbOldClockTicks = clockTicks-1;
+      gbIntBreak = 1;
+    }
+
+
+    if(!emulating)
+      return;
+
+    // For 'breakpoint' support (opcode 0xFC is considered as a breakpoint)
+    if ((clockTicks==0) && execute)
+    {
+      PC.W = oldPCW;
+      return;
+    }
+
+
+    if (!(IFF & 0x80))
+      clockTicks = 1;
+
+    gbRedoLoop:
+
+
+
+    if (gbInterruptWait)
+      gbInterruptWait = 0;
+    else
+      gbInterruptLaunched = 0;
+
+
+    // Used for the EI/DI instruction's delay.
+    if (IFF & 0x38)
+    {
+        int tempIFF = (IFF >> 4) & 3;
+            
+        if (tempIFF <=clockTicks)
+        {
+            tempIFF = 0;
+            IFF |=1;
+        }
+        else
+          tempIFF -= clockTicks;
+        IFF = (IFF & 0xCF) | (tempIFF <<4);
+
+        if (IFF & 0x08)
+          IFF &= 0x82;
     }
 
-    if(!emulating)
-      return;
 
-    if(gbDmaTicks) {
-      clockTicks += gbDmaTicks;
-      gbDmaTicks = 0;
+    if (register_LCDCBusy)
+    {
+      register_LCDCBusy-=clockTicks;
+      if (register_LCDCBusy<0)
+        register_LCDCBusy = 0;
     }
 
+
     if(gbSgbMode) {
       if(gbSgbPacketTimeout) {
         gbSgbPacketTimeout -= clockTicks;
